import gtk

class CalendarDialogException(Exception):
	def __init__(self, message):
		Exception.__init__(self, message)

class CalendarDialog(gtk.Dialog):
	def __init__(self, title=None, parent=None, flags=0):
		#init members
		self.__year = -1
		self.__month = -1
		self.__day = -1
		
		#super constructor
		gtk.Dialog.__init__(self, title, parent, flags, (gtk.STOCK_OK, gtk.RESPONSE_OK, gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL))
	
	def run(self):
		#create calendar
		self.__calendar = gtk.Calendar()
		
		#set date
		if self.__year!=-1 and self.__month!=-1 and self.__day!=-1:
			self.__calendar.select_month(self.__month, self.__year)
			self.__calendar.select_day(self.__day)
			
		#add calendar to dialog
		self.vbox.pack_start(self.__calendar, True, True, 2)
		self.__calendar.show()
		
		return gtk.Dialog.run(self)
		
	def set_date(self, year, month, day):
		#set month
		if month>=0 and month<=11:
			self.__month = month
		else:
			raise CalendarDialogException('Month is zero-based (i.e it allowed values are 0-11)')
			
		#set year
		self.__year = year
		
		#set day
		if day<1 or day>31:
			raise CalendarDialogException('Day is one-based (i.e. allowed values are 1-31)')
		else:
			self.__day = day
	
	def get_date(self):
		return self.__calendar.get_date()
		