import gtk
import pygtk
import math

class Rectangle():
	def __init__(self, x=0, y=0, width=0, height=0):
		self.x = x
		self.y = y
		self.width = width
		self.height = height
		
	def copy(self, rect):
		self.x = rect.x
		self.y = rect.y
		self.width = rect.width
		self.height = rect.height
			
	##See gtk.gdk.Rectangle.intersect() for information
	##@return geometry.Rectangle : rectangle representing the intersection. All values are set to 0 if no intersection
	def intersect(self, rect):
		me = gtk.gdk.Rectangle(self.x, self.y, self.width, self.height)
		you = gtk.gdk.Rectangle(rect.x, rect.y, rect.width, rect.height)
		intersect = me.intersect(you)
		return Rectangle(intersect.x, intersect.y, intersect.width, intersect.height)
	
	def __str__(self):
		return 'Rectangle(x=%d, y=%d, width=%d, height=%d)' % (self.x, self.y, self.width, self.height)

class Point():
	def __init__(self, x=0, y=0):
		self.x = x
		self.y = y
		
	def copy(self, point):
		self.x = point.x
		self.y = point.y
	
	def __str__(self):
		return 'Point(x=%d, y=%d)' % (self.x, self.y)
		
	def distance(self, point):
		return math.sqrt( math.pow((point.x - self.x), 2) + math.pow((point.y - self.y), 2))
	
	def xDistance(self, point):
		return self.x - point.x
		
	def yDistance(self, point):
		return self.y - point.y