import datetime
import sys
import os
import shutil

##Log class
class Log():
	##Constants
	LOG_ACTION_PURGE = 0
	LOG_ACTION_ROTATE = 1
	
	LOG_FILENAME = 'log.log'
	LOG_STDOUT = False
	LOG_STDERR = False
	LOG_FILE = True
	LOG_MAX_SIZE = 1000000000 #in bytes
	LOG_MAX_ROTATE = 2
	LOG_ACTION = 1
	
	#add log
	def log(message):
		#prepare string to log
		now = datetime.datetime.now()
		log = now.strftime('%Y-%m-%d %H:%M:%S')+' : '+str(message)+'\n'
		
		#log to stdout
		if Log.LOG_STDOUT:
			sys.stdout.write(log)
			
		#log to stderr
		if Log.LOG_STDERR:
			sys.stderr.write(log)
		
		#log to file
		if Log.LOG_FILE:
			#action on log file
			if Log.LOG_ACTION==Log.LOG_ACTION_ROTATE:
				Log.rotate()
			else:
				Log.purge()
		
			#log message
			f = open(Log.LOG_FILENAME, 'a')
			try:
				f.write(log)
			finally:
				f.close()
	log = staticmethod(log)
	
	##rotate log files
	def rotate():
		if os.path.exists(Log.LOG_FILENAME):
			#get file infos
			infos = os.stat(Log.LOG_FILENAME)
			
			#check file size
			if infos.st_size>Log.LOG_MAX_SIZE:
				#delete last file
				if os.path.exists(Log.LOG_FILENAME + str(Log.LOG_MAX_ROTATE)):
					os.remove(Log.LOG_FILENAME + str(Log.LOG_MAX_ROTATE))
				
				#rename existing ones
				for i in range(Log.LOG_MAX_ROTATE-1, 0, -1):
					if os.path.exists(Log.LOG_FILENAME + str(i)):
						#rename
						os.rename(Log.LOG_FILENAME + str(i), Log.LOG_FILENAME + str(i+1))
				
				#rename currentlog file
				os.rename(Log.LOG_FILENAME, Log.LOG_FILENAME + str(1))
	rotate = staticmethod(rotate)
	
	##Purge log file
	def purge():
		if os.path.exists(Log.LOG_FILENAME):
			#get file infos
			infos = os.stat(Log.LOG_FILENAME)
		
			#check file size
			if infos.st_size>Log.LOG_MAX_SIZE:
				try:
					os.remove(Log.LOG_FILENAME)
				except:
					pass
	purge = staticmethod(purge)
